;****************************************************************************
; MODULO DE AUDIO - SPEAKER
;
; Frecuencias de las notas musicales:
;    C    C# D-  D    D# E-  E     F    F# G-  G    G# A-  A    A# B-  B
;   0033  0035  0037  0039  0041  0044  0046  0049  0052  0055  0058  0062
;   0065  0069  0073  0078  0082  0087  0093  0098  0104  0110  0117  0123
;   0131  0139  0147  0156  0165  0175  0185  0196  0208  0220  0233  0247
;   0262  0277  0294  0311  0330  0349  0370  0392  0415  0440  0466  0494
;   0523  0554  0587  0622  0659  0698  0740  0784  0831  0880  0932  0987
;   1047  1109  1175  1245  1329  1397  1480  1568  1661  1760  1865  1976
;   2093  2217  2349  2489  2637  2794  2960  3136  3322  3520  3729  3951
;   4186  4435  4699  4978  5274  5588  5920  6272  6645  7040  7459  7902
;
;   Cada fila forma una octava.
;****************************************************************************

;****************************************************************************
; Define los valores.
;****************************************************************************

PUBLIC MAS_CONECTA_ALTAVOZ
PUBLIC MAS_DESCONECTA_ALTAVOZ

PUBLIC MAS_ENVIA_SONIDO

FRECUENCIA_RELOJ_1   = 00012H
FRECUENCIA_RELOJ_2   = 034DDH
PUERTO_CONTROL_RELOJ = 043H
PUERTO_CANAL_2_RELOJ = 042H
PUERTO_ALTAVOZ       = 061H

CAMINO SEGMENT PUBLIC
  ASSUME CS:CAMINO,DS:CAMINO,SS:CAMINO,ES:CAMINO

  DB 'MAS 1998 Marco Antonio Alvarado'

;****************************************************************************
; Conecta el altavoz al canal 2 del reloj. Se necesita este paso para
; escuchar el sonido.
;****************************************************************************

  LABEL MAS_CONECTA_ALTAVOZ NEAR
  CONECTA_ALTAVOZ PROC NEAR
    PUSH AX

    IN AL,PUERTO_ALTAVOZ
    OR AL,3
    OUT PUERTO_ALTAVOZ,AL

    POP AX
    RET
  CONECTA_ALTAVOZ ENDP

;****************************************************************************
; Desconecta el altavoz del reloj.
;****************************************************************************

  LABEL MAS_DESCONECTA_ALTAVOZ NEAR
  DESCONECTA_ALTAVOZ PROC NEAR
    PUSH AX

    IN AL,PUERTO_ALTAVOZ
    AND AL,0FCH
    OUT PUERTO_ALTAVOZ,AL

    POP AX
    RET
  DESCONECTA_ALTAVOZ ENDP

;****************************************************************************
; Enva un sonido con cierta frecuencia al altavoz. Conecta el altavoz antes
; de realizar esta operacin.
;
; Necesita:
;   AX = frecuencia (1..). El valor 0 causar un error fatal de divisin.
;
; Llama:
;   CONECTA_ALTAVOZ
;****************************************************************************

  LABEL MAS_ENVIA_SONIDO NEAR
  ENVIA_SONIDO PROC NEAR
    PUSH DX
    PUSH BX
    PUSH AX

    CALL CONECTA_ALTAVOZ

;----------------------------------------------------------------------------
; Estable la frecuencia del canal 2 del reloj.
    MOV DX,FRECUENCIA_RELOJ_1
    MOV BX,FRECUENCIA_RELOJ_2
    XCHG AX,BX
    DIV BX
    XCHG AX,BX
    MOV AL,0B6H
    OUT PUERTO_CONTROL_RELOJ,AL
    XCHG AX,BX
    OUT PUERTO_CANAL_2_RELOJ,AL
    XCHG AL,AH
    OUT PUERTO_CANAL_2_RELOJ,AL

    POP AX
    POP BX
    POP DX
    RET
  ENVIA_SONIDO ENDP

CAMINO ENDS

END