;****************************************************************************
; MODULO DE AUDIO - SPEAKER
;
; PRUEBA 1 - Toca una frecuencia con el parlante.
;****************************************************************************

;****************************************************************************
; Define los valores.
;****************************************************************************

  PUBLIC MAS_SUENA_FRECUENCIA
  PUBLIC MAS_CALLA_FRECUENCIA

  FRECUENCIA_RELOJ_1   = 00012H
  FRECUENCIA_RELOJ_2   = 034DDH
  PUERTO_CONTROL_RELOJ = 043H
  PUERTO_CANAL_2_RELOJ = 042H
  PUERTO_BOCINA        = 061H

CAMINO SEGMENT PUBLIC
  ASSUME CS:CAMINO,DS:CAMINO,SS:CAMINO,ES:CAMINO

  DB 'MAS 1998 Marco Antonio Alvarado'

;****************************************************************************
; Suena una frecuencia con el parlante un tiempo indeterminado.
;
; Necesita:
;   AX = frecuencia (1..). El valor 0 causar un error de divisin.
;****************************************************************************

  LABEL MAS_SUENA_FRECUENCIA NEAR
  SUENA_FRECUENCIA PROC NEAR
    PUSH DX
    PUSH BX
    PUSH AX

;----------------------------------------------------------------------------
; Estable la frecuencia del canal 2 del reloj.
    MOV DX,FRECUENCIA_RELOJ_1
    MOV BX,FRECUENCIA_RELOJ_2
    XCHG AX,BX
    DIV BX
    XCHG AX,BX
    MOV AL,0B6H
    OUT PUERTO_CONTROL_RELOJ,AL
    XCHG AX,BX
    OUT PUERTO_CANAL_2_RELOJ,AL
    XCHG AL,AH
    OUT PUERTO_CANAL_2_RELOJ,AL

;----------------------------------------------------------------------------
; Conecta la bocina al reloj.
    IN AL,PUERTO_BOCINA
    OR AL,3
    OUT PUERTO_BOCINA,AL

    POP AX
    POP BX
    POP DX
    RET
  SUENA_FRECUENCIA ENDP

;****************************************************************************
; Detiene la frecuencia que toca el parlante.
;****************************************************************************

  LABEL MAS_CALLA_FRECUENCIA NEAR
  CALLA_FRECUENCIA PROC NEAR
    PUSH AX

;----------------------------------------------------------------------------
; Desconecta la bocina del reloj.
    IN AL,PUERTO_BOCINA
    AND AL,0FCH
    OUT PUERTO_BOCINA,AL

    POP AX
    RET
  CALLA_FRECUENCIA ENDP

CAMINO ENDS

END