;****************************************************************************
; MODULO DE AUDIO - SPEAKER
;
; PRUEBA 2
; Toca msica en el fondo.
;
; Frecuencias de las notas musicales:
;    C    C# D-  D    D# E-  E     F    F# G-  G    G# A-  A    A# B-  B
;   0033  0035  0037  0039  0041  0044  0046  0049  0052  0055  0058  0062
;   0065  0069  0073  0078  0082  0087  0093  0098  0104  0110  0117  0123
;   0131  0139  0147  0156  0165  0175  0185  0196  0208  0220  0233  0247
;   0262  0277  0294  0311  0330  0349  0370  0392  0415  0440  0466  0494
;   0523  0554  0587  0622  0659  0698  0740  0784  0831  0880  0932  0987
;   1047  1109  1175  1245  1329  1397  1480  1568  1661  1760  1865  1976
;   2093  2217  2349  2489  2637  2794  2960  3136  3322  3520  3729  3951
;   4186  4435  4699  4978  5274  5588  5920  6272  6645  7040  7459  7902
;
;   Cada fila forma una octava.
;****************************************************************************

;****************************************************************************
; Define los valores.
;****************************************************************************

  PUBLIC MAS_SUENA_FRECUENCIA
  PUBLIC MAS_CALLA_FRECUENCIA

  FRECUENCIA_RELOJ_1   = 00012H
  FRECUENCIA_RELOJ_2   = 034DDH
  PUERTO_CONTROL_RELOJ = 043H
  PUERTO_CANAL_2_RELOJ = 042H
  PUERTO_BOCINA        = 061H

CAMINO SEGMENT PUBLIC
  ASSUME CS:CAMINO,DS:CAMINO,SS:CAMINO,ES:CAMINO

  DB 'MAS 1998 Marco Antonio Alvarado'

;****************************************************************************
; Suena una frecuencia con el parlante un tiempo indeterminado.
;
; Necesita:
;   AX = frecuencia (1..). El valor 0 causar un error de divisin.
;****************************************************************************

  LABEL MAS_SUENA_FRECUENCIA NEAR
  SUENA_FRECUENCIA PROC NEAR
    PUSH DX
    PUSH BX
    PUSH AX

;----------------------------------------------------------------------------
; Estable la frecuencia del canal 2 del reloj.
    MOV DX,FRECUENCIA_RELOJ_1
    MOV BX,FRECUENCIA_RELOJ_2
    XCHG AX,BX
    DIV BX
    XCHG AX,BX
    MOV AL,0B6H
    OUT PUERTO_CONTROL_RELOJ,AL
    XCHG AX,BX
    OUT PUERTO_CANAL_2_RELOJ,AL
    XCHG AL,AH
    OUT PUERTO_CANAL_2_RELOJ,AL

;----------------------------------------------------------------------------
; Conecta la bocina al reloj.
    IN AL,PUERTO_BOCINA
    OR AL,3
    OUT PUERTO_BOCINA,AL

    POP AX
    POP BX
    POP DX
    RET
  SUENA_FRECUENCIA ENDP

;****************************************************************************
; Detiene la frecuencia que toca el parlante.
;****************************************************************************

  LABEL MAS_CALLA_FRECUENCIA NEAR
  CALLA_FRECUENCIA PROC NEAR
    PUSH AX

;----------------------------------------------------------------------------
; Desconecta la bocina del reloj.
    IN AL,PUERTO_BOCINA
    AND AL,0FCH
    OUT PUERTO_BOCINA,AL

    POP AX
    RET
  CALLA_FRECUENCIA ENDP

CAMINO ENDS

END