{***************************************************************************}
{                             UNIDAD DE BOCINA

                                  Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

UNIT UBocina;

INTERFACE

  TYPE
    PSonido = ^RSonido;

    RSonido = RECORD
      Frecuencia,
      Duracion : Word;
    END;

  VAR
    Silencio,
    Repite : Boolean;

  PROCEDURE Suena (Frecuencia : Word);
  PROCEDURE Calla;

IMPLEMENTATION

  CONST
{PIT = Programmable Interval Timer}
    FrecuenciaPIT = $1234dd;
    ControlPIT = $43;
    Canal2PIT = $42;
    PuertoBocina = $61;
    InterrupcionReloj = $1c;

  VAR
    ViejaAtiende,
    Inicio,
    Lugar : PSonido;
    Cantidad,
    Indice : LongInt;
    Frecuencia,
    Duracion : Word;
    Activo,
    Toca : Boolean;

  PROCEDURE Suena (Frecuencia : Word);

    VAR
      Cuenta : Word;

  BEGIN

    IF Frecuencia > 0 THEN
    BEGIN
{Programa el Programmable Interval Timer (PIT).}
{$r-}
      Cuenta := FrecuenciaPIT DIV Frecuencia;
{$r+}
      Port [ControlPIT] := $b6;
      Port [Canal2PIT] := Lo (Cuenta);
      Port [Canal2PIT] := Hi (Cuenta);

{Conecta la Bocina al PIT.}
      Port [PuertoBocina] := Port [PuertoBocina] OR 3;
    END ELSE
      IF Silencio THEN
      BEGIN
        Calla;
      END;

  END;

  PROCEDURE Calla;
  BEGIN
{Desconecta la Bocina del PIT.}
    Port [PuertoBocina] := Port [PuertoBocina] AND $fc;
  END;

BEGIN
  Silencio := True;
  Repite := False;
  Activo := False;
  Toca := False;
END.